Index: ode/src/joints/lmplus.cpp
===================================================================
--- ode/src/joints/lmplus.cpp	(revision 0)
+++ ode/src/joints/lmplus.cpp	(working copy)
@@ -0,0 +1,672 @@
+/*************************************************************************
+ *                                                                       *
+ * LMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+
+#include "config.h"
+#include "lmplus.h"
+#include "joint_internal.h"
+
+
+//****************************************************************************
+// lmplus joint
+dxJointLMPlus::dxJointLMPlus( dxWorld *w ) 
+: dxJoint( w )
+{
+    int ii;
+    for ( ii = 0;ii < 3;ii++ ) {
+			frame[ii]=0; // Default to world frame
+      dSetZero( axis[ii], 4 );
+			axis[ii][ii]=1; // Default to x,y,z axes
+      limot[ii].init( world ); // Initialize the limots
+			mode[ii] = 0; // Linear (box) mode.
+    }
+		dSetZero(anchor1,4);  // Default anchor position to CoM of body
+		dSetZero(anchor2,4);
+}
+	
+/**
+	In order to create a constraint row,
+	we need to know the global axis, the global anchors,
+	the current distance between the anchors
+	along the global axis, and the desired value.
+	For unilateral limits, we also need to know the relative velocity
+	of the points along the axis.
+*/
+dReal dxJointLMPlus::interPointDistance(dVector3 ax,int ii)
+{
+	dVector3 pt1, pt2;
+	dReal dist;
+
+	dVector3 sepVec;
+
+	// Move the anchors from local frames
+	// into the world frame.
+	getAnchor(this, pt1, anchor1);
+	getAnchor2(this, pt2, anchor2);
+
+	// Find the vector between anchor1 and anchor2
+	dSubtractVectors3(sepVec,pt1,pt2);
+
+	switch(mode[ii]) {
+		case dLMPlusPlanar: // The planar case 
+		default:
+			// Rotate the axis from its local frame of reference
+			// into the world frame
+			computeGlobalAxis(ax,ii);
+			dist = dCalcVectorDot3(ax,sepVec);
+			break;
+		case dLMPlusCylindrical: {// The cylindrical case
+			dVector3 norm,qq;
+			computeGlobalAxis(norm,ii);
+			
+			// Find the anchor separation vector
+			// as projected onto the planeSpace
+			if (dDirectedPlaneSpace(norm,sepVec,ax,qq)) {
+				dist = dCalcVectorDot3(ax,sepVec);
+			} else {
+				// The projected anchors are on top of each other
+				dist = 0;
+				// We'll try to find an axis based on the relative
+				// velocity of the anchors since they're moving that 
+				// way already.  Better still might be to use the 
+				// previous frame's axis; but doing so would introduce
+				// some nastiness.
+				dVector3 av1,av2;
+				if (node[0].body) {
+					dBodyGetRelPointVel(node[0].body,anchor1[0],anchor1[1],anchor1[2],av1);
+				} else {
+					dSetZero(av1,3);
+				}
+				if (node[1].body) {
+					dBodyGetRelPointVel(node[1].body,anchor2[0],anchor2[1],anchor2[2],av2);
+				} else {
+					dSetZero(av2,3);
+				}
+				// Find the relative velocity of the anchor points
+				dVector3 relVel;
+				dSubtractVectors3(relVel,av2,av1);
+				// Project the velocity onto the planespace.
+				dReal rvP = dCalcVectorDot3(ax,relVel);
+				dReal rvQ = dCalcVectorDot3(qq,relVel);
+				if (rvP!=0 || rvQ!=0) {
+					dReal lenRecip = dRecipSqrt(rvP*rvP + rvQ*rvQ);
+					dAddScaledVectors3(ax,ax,qq,rvP*lenRecip,rvQ*lenRecip);
+				} else {
+					// The projected relative velocity is also zero.
+					// So we just use the arbitrary axis found by dPlaneSpace.
+				}
+			}
+		} break;
+		case dLMPlusSpherical: { // The spherical case
+			if (sepVec[0]!=0 || sepVec[1]!=0 || sepVec[2]!=0) {
+				// The vector between the two anchors is the axis
+				// of control.
+				dist = dSqrt(sepVec[0]*sepVec[0] + sepVec[1]*sepVec[1] + sepVec[2]*sepVec[2]);
+				dCopyScaledVector3(ax,sepVec,dRecip(dist));
+			} else {
+				// As in the cylindrical case, if the anchors are
+				// on top of each other, we'll try using the relative 
+				// velocity.
+				dist = 0;
+
+				dVector3 av1,av2;
+				if (node[0].body) {
+					dBodyGetRelPointVel(node[0].body,anchor1[0],anchor1[1],anchor1[2],av1);
+				} else {
+					dSetZero(av1,3);
+				}
+				if (node[1].body) {
+					dBodyGetRelPointVel(node[1].body,anchor2[0],anchor2[1],anchor2[2],av2);
+				} else {
+					dSetZero(av2,3);
+				}
+				// Find the relative velocity of the anchor points
+				
+				dSubtractVectors3(ax,av2,av1);
+				if (ax[0]!=0 || ax[1]!=0 || ax[2]!=0) {
+					dNormalize3(ax);				
+				} else {
+					// Use a default axis
+					// Our other option would be 
+					// to leave ax[] unchanged.  Since we 
+					// cache the value, this could be a good
+					// choice, but doing so adds unexposed 
+					// state that could make a joint behave
+					// differently in different trials
+					// even when set with the same values.
+					ax[0] = 1;
+					ax[1] = 0;
+					ax[2] = 0;
+				}
+			}
+		} break;
+	}
+	return dist;
+}
+
+/**
+	Find the axis that constrains the 
+	anchor points.
+
+	We naturally find the distance between
+	the points in the process.
+*/
+void
+dxJointLMPlus::computeGlobalAxis( dVector3 ax, int ii )
+{
+	
+	// If we're in linear or planar mode, we need
+	// to find the axis in global coordinates
+	if (frame[ii]==1 && node[0].body) {
+		dMultiply0_331( ax, node[0].body->posr.R, axis[ii] );
+	} else if (frame[ii]==2 && node[1].body) {
+		dMultiply0_331( ax, node[1].body->posr.R, axis[ii] );
+	} else {
+		dCopyVector3(ax,axis[ii]);
+	}
+}
+
+
+void 
+dxJointLMPlus::getSureMaxInfo( SureMaxInfo* info )
+{
+  info->max_m = 0;
+  for (int ii=0;ii<3;++ii) {
+    info->max_m += limot[ii].countSureMaxRows();
+  }
+}
+
+/**
+	To determine how many constraints are active,
+	we'll check to see if hiStop/loStop are set
+	or if fMax is non-zero.  If hiStop/loStop are set
+	and they're equal, we have a constraint and it
+	doesn't matter what fMax says.  
+	If they're past each other, the constraint is disabled.
+	Otherwise,
+	we need to check to see if we're past/at one of the 
+	stops.  That requires finding that axes and points in 
+	world	coordinates.  It's annoying that we'll have to
+	do that again for getInfo2.
+*/
+void dxJointLMPlus::getInfo1( dxJoint::Info1 *info )
+{
+  info->m = 0;
+  info->nub = 0;
+
+	// For each limot'ed axis
+	for (int ii=0;ii<3;++ii) {
+		if (limot[ii].isActive()) {
+			// Compute the axis/distance and cache them.
+			dReal dist = interPointDistance(cacheAxis[ii],ii);
+			// This mis-named function sets the error
+			// and direction of the error in the limit-motor
+			limot[ii].testRotationalLimit( dist );
+
+			info->m += limot[ii].countRows();
+			info->nub += limot[ii].countUBRows();
+		}
+	}
+}
+
+/**
+	For each degree of freedom, set the constraint rows.
+*/
+void dxJointLMPlus::getInfo2( dxJoint::Info2 *info )
+{
+	int row = 0;
+	dVector3 pt1, pt2;
+
+	// We need the anchors re-oriented to the
+	// the global frame, but not translated.
+	// getAxis() doesn't add in the body's POR
+	// like getAnchor() does; so we use it.
+	getAxis (this,pt1, anchor1);
+	getAxis2(this,pt2, anchor2);
+
+	for (int ii=0;ii<3;++ii) {
+		row += limot[ii].addPointLinearLimot(this,info,pt1,pt2,cacheAxis[ii],row);
+	}
+}
+
+dJointType dxJointLMPlus::type() const
+{
+  return dJointTypeLMPlus;
+}
+
+
+size_t dxJointLMPlus::size() const
+{
+  return sizeof( *this );
+}
+
+/////////////////////////////////////////////////////////////
+// Public API functions
+/////////////////////////////////////////////////////////////
+void dJointSetLMPlusAnchors( dJointID j, dReal x1, dReal y1, dReal z1, dReal x2, dReal y2, dReal z2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	setAnchors(joint, x1, y1, z1, joint->anchor1, 0);
+	setAnchors(joint, x2, y2, z2, 0, joint->anchor2);
+}
+
+void dJointSetLMPlusAnchorsV( dJointID j, const dVector3 a1, const dVector3 a2)
+{
+	dAASSERT( 		
+		a1 &&
+		a2
+	);
+
+	dJointSetLMPlusAnchors( j, a1[0], a1[1], a1[2], a2[0], a2[1], a2[2]);
+}
+
+void dJointSetLMPlusAnchorsRel( dJointID j, dReal x1, dReal y1, dReal z1, dReal x2, dReal y2, dReal z2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	joint->anchor1[0]=x1;
+	joint->anchor1[1]=y1;
+	joint->anchor1[2]=z1;
+
+	joint->anchor2[0]=x2;
+	joint->anchor2[1]=y2;
+	joint->anchor2[2]=z2;
+}
+
+void dJointSetLMPlusAnchorsRelV( dJointID j, const dVector3 a1, const dVector3 a2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		a1 &&
+		a2
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(joint->anchor1, a1);
+	dCopyVector3(joint->anchor2, a2);
+}
+
+void dJointSetLMPlusAnchor1( dJointID j, dReal x1, dReal y1, dReal z1)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	setAnchors(joint, x1, y1, z1, joint->anchor1, 0);
+}
+
+void dJointSetLMPlusAnchor1V( dJointID j, const dVector3 a1)
+{
+	dAASSERT( a1 );
+
+	dJointSetLMPlusAnchor1(j, a1[0], a1[1], a1[2]);
+}
+
+void dJointSetLMPlusAnchor2( dJointID j, dReal x2, dReal y2, dReal z2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	setAnchors(joint, x2, y2, z2, 0, joint->anchor2);
+}
+
+void dJointSetLMPlusAnchor2V( dJointID j, const dVector3 a2)
+{
+	dAASSERT(	a2 );
+
+	dJointSetLMPlusAnchor2(j, a2[0], a2[1], a2[2] );
+}
+
+void dJointSetLMPlusAnchor1Rel( dJointID j, dReal x1, dReal y1, dReal z1)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	joint->anchor1[0] = x1;
+	joint->anchor1[1] = y1;
+	joint->anchor1[2] = z1;
+}
+
+void dJointSetLMPlusAnchor1RelV( dJointID j, const dVector3 a1)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		a1
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(joint->anchor1,a1);
+}
+
+void dJointSetLMPlusAnchor2Rel( dJointID j, dReal x2, dReal y2, dReal z2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( joint );
+	checktype( joint, LMPlus );
+
+	joint->anchor2[0] = x2;
+	joint->anchor2[1] = y2;
+	joint->anchor2[2] = z2;
+}
+
+
+void dJointSetLMPlusAnchor2RelV( dJointID j, const dVector3 a2)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		a2
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(joint->anchor2,a2);
+}
+
+void dJointSetLMPlusAxis( dJointID j, int anum, int frame, dReal x, dReal y, dReal z)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2 &&
+		frame >= 0 &&
+		frame <= 2
+	);
+	checktype( joint, LMPlus );
+
+	joint->frame[anum] = frame;
+
+	// Transform the axis from global frame
+	// into 'frame' frame.
+	switch (frame) {
+		case 1:
+			setAxes(joint, x,y,z, joint->axis[anum], 0);
+			break;
+		case 2:
+			setAxes(joint, x,y,z, 0, joint->axis[anum]);
+			break;
+		case 0:
+		default:
+			joint->axis[anum][0] = x;
+			joint->axis[anum][1] = y;
+			joint->axis[anum][2] = z;
+			break;
+	}
+}
+
+void dJointSetLMPlusAxisV( dJointID j, int anum, int frame, const dVector3 ax)
+{
+	dAASSERT( ax );
+	dJointSetLMPlusAxis(j, anum, frame, ax[0], ax[1], ax[2]);
+}
+
+void dJointSetLMPlusAxisRel( dJointID j, int anum, int frame, dReal x, dReal y, dReal z)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2 &&
+		frame >= 0 &&
+		frame <= 2
+	);
+	checktype( joint, LMPlus );
+
+	joint->frame[anum] = frame;
+	joint->axis[anum][0] = x;
+	joint->axis[anum][1] = y;
+	joint->axis[anum][2] = z;
+}
+
+void dJointSetLMPlusAxisRelV( dJointID j, int anum, int frame, const dVector3 ax)
+{
+	dAASSERT( ax );
+
+	dJointSetLMPlusAxisRel(j,anum,frame,ax[0],ax[1],ax[2]);
+}
+
+void dJointSetLMPlusMode( dJointID j, int anum, int mode)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	joint->mode[anum] = mode;
+}
+
+void dJointGetLMPlusAnchor1( const dJointID j, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		res
+	);
+	checktype( joint, LMPlus );
+
+	getAnchor(joint, res, joint->anchor1);
+}
+
+void dJointGetLMPlusAnchor1Rel( const dJointID j, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		res
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(res, joint->anchor1);
+}
+
+void dJointGetLMPlusAnchor2( const dJointID j, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		res
+	);
+	checktype( joint, LMPlus );
+
+	getAnchor2(joint, res, joint->anchor2);
+}
+
+void dJointGetLMPlusAnchor2Rel( const dJointID j, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		res
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(res, joint->anchor2);
+}
+
+void dJointGetLMPlusAxis( const dJointID j, int anum, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2 &&
+		res
+	);
+	checktype( joint, LMPlus );
+
+	switch (joint->frame[anum]) {
+		case 1:
+			getAxis(joint, res, joint->axis[anum]);
+			break;
+		case 2:
+			getAxis2(joint, res, joint->axis[anum]);
+			break;
+		case 0:
+		default:
+			dCopyVector3(res, joint->axis[anum]);
+			break;
+	}
+}
+
+void dJointGetLMPlusAxisRel( const dJointID j, int anum, dVector3 res)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2 &&
+		res
+	);
+	checktype( joint, LMPlus );
+
+	dCopyVector3(res, joint->axis[anum]);
+}
+
+int dJointGetLMPlusAxisFrame( const dJointID j, int anum)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	return joint->frame[anum];
+}
+
+int dJointGetLMPlusMode( const dJointID j, int anum)
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	return joint->mode[anum];
+}
+
+// In planar or spherical mode,
+// the actual axis of constraint is
+// not given in axis[n]
+void dJointGetLMPlusEffectiveAxis( const dJointID j, int anum, dVector3 res )
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	joint->interPointDistance(res, anum);
+	
+}
+
+// How far apart are the anchors along the effective axis
+dReal dJointGetLMPlusSeparation( const dJointID j, int anum )
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	dVector3 ax;
+	return joint->interPointDistance(ax,anum);
+}
+
+// How fast are the anchors moving along the effective axis
+dReal dJointGetLMPlusSeparationRate( const dJointID j, int anum )
+{
+	dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+	dAASSERT( 
+		joint && 
+		anum >= 0 && 
+		anum <= 2
+	);
+	checktype( joint, LMPlus );
+
+	dVector3 ax,ang;
+	dVector3 pt;
+
+	joint->interPointDistance(ax,anum);
+
+	getAxis (joint,pt,joint->anchor1);
+	dCalcVectorCross3(ang,pt,ax);
+
+	dReal vel = dCalcVectorDot3( joint->node[0].body->lvel, ax) +
+				      dCalcVectorDot3( joint->node[0].body->avel, ang);
+	if (joint->node[1].body) {
+		getAxis2(joint,pt,joint->anchor2);
+		dCalcVectorCross3(ang,pt,ax);
+		vel -=
+					dCalcVectorDot3( joint->node[1].body->lvel, ax) +
+					dCalcVectorDot3( joint->node[1].body->avel, ang);
+	}
+
+	return vel;
+}
+
+void dJointSetLMPlusParam( dJointID j, int parameter, dReal value )
+{
+    dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+    dAASSERT( joint );
+    checktype( joint, LMPlus );
+    int anum = parameter >> 8;
+    if ( anum < 0 ) anum = 0;
+    if ( anum > 2 ) anum = 2;
+    parameter &= 0xff;
+    joint->limot[anum].set( parameter, value );
+}
+
+dReal dJointGetLMPlusParam( dJointID j, int parameter )
+{
+    dxJointLMPlus* joint = ( dxJointLMPlus* )j;
+    dAASSERT( joint );
+    checktype( joint, LMPlus );
+    int anum = parameter >> 8;
+    if ( anum < 0 ) anum = 0;
+    if ( anum > 2 ) anum = 2;
+    parameter &= 0xff;
+    return joint->limot[anum].get( parameter );
+}
+
+
+
Index: ode/src/joints/lmplus.h
===================================================================
--- ode/src/joints/lmplus.h	(revision 0)
+++ ode/src/joints/lmplus.h	(working copy)
@@ -0,0 +1,84 @@
+/*************************************************************************
+ *                                                                       *
+ * LMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+#ifndef _ODE_JOINT_LMPLUS_H_
+#define _ODE_JOINT_LMPLUS_H_
+
+#include "joint.h"
+
+/*
+	The LMotor controls the linear velocity between
+	the center of mass of two bodies or a body and the world.
+	This joint builds on that, allowing you to set an 
+	arbitrary anchor point besides the center of mass for
+	each body.  It also lets you constrain the distance 
+	between those anchors instead of just the velocity.
+*/
+struct dxJointLMPlus : public dxJoint
+{
+    int frame[3];       // frame of reference for axis[]
+		dVector3 anchor1; // anchor w.r.t. body1
+		dVector3 anchor2; // anchor w.r.t. body2
+    dVector3 axis[3]; // axis along which the constraint is applied
+		// dLMPlusLinear, dLMPlusPlanar, dLMPlusSpherical
+		// In linear mode, the anchor points are constrained
+		// along the axis[].  A single axis in linear mode
+		// will constrain one anchor to a plane relative to
+		// the other anchor.
+		// In planar mode, the anchor points are constrained
+		// within the planespace defined by the axis[].  A single
+		// axis in planar mode will constrain one anchor to
+		// a cylinder relative to the other anchor
+		// In spherical mode, the axis[] isn't used.  The anchors
+		// are constrained to maintain offset[] distance from 
+		// each other.  A single axis in spherical mode will 
+		// constrain one anchor to a sphere relative to the other 
+		// anchor.
+		
+		int mode[3];  
+		// The limot holds hiStop/loStop information
+		// used by the joint.
+		// A negative loStop/hiStop doesn't make sense for
+		// the planar/spherical modes because they use 
+		// absolute distance.
+    dxJointLimitMotor limot[3];
+		
+		// We need to compute the effective axis in "getInfo1".
+		// Since the computation is non-trivial, we cache
+		// it here.
+		dVector3 cacheAxis[3];
+
+    void computeGlobalAxis( dVector3 ax, int ii );
+		dReal interPointDistance(dVector3 ax, int ii);
+
+    dxJointLMPlus( dxWorld *w );
+    virtual void getSureMaxInfo( SureMaxInfo* info );
+    virtual void getInfo1( Info1* info );
+    virtual void getInfo2( Info2* info );
+    virtual dJointType type() const;
+    virtual size_t size() const;
+};
+
+
+#endif
+
Index: ode/src/joints/Makefile.am
===================================================================
--- ode/src/joints/Makefile.am	(revision 1903)
+++ ode/src/joints/Makefile.am	(working copy)
@@ -22,5 +22,7 @@
                         plane2d.h plane2d.cpp \
                         pu.h pu.cpp \
                         pr.h pr.cpp \
-                        piston.h piston.cpp
+                        piston.h piston.cpp \
+                        amplus.h amplus.cpp \
+                        lmplus.h lmplus.cpp
 
Index: ode/src/joints/piston.cpp
===================================================================
--- ode/src/joints/piston.cpp	(revision 1903)
+++ ode/src/joints/piston.cpp	(working copy)
@@ -175,7 +175,7 @@
 void 
 dxJointPiston::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 4 + limotP.countSureMaxRows() + limotR.countSureMaxRows();
 }
 
 
@@ -198,7 +198,8 @@
     }
 
     // powered Piston or at limits needs an extra constraint row
-    if ( limotP.limit || limotP.fmax > 0 ) info->m++;
+    info->m += limotP.countRows();
+    info->nub += limotP.countUBRows();
 
 
     // see if we're at a joint limit.
@@ -213,7 +214,8 @@
     }
 
     // powered Piston or at limits needs an extra constraint row
-    if ( limotR.limit || limotR.fmax > 0 ) info->m++;
+    info->m += limotR.countRows();
+    info->nub += limotR.countUBRows();
 
 }
 
@@ -406,7 +408,7 @@
     int row = 4;
     if (  node[1].body )
     {
-        row += limotP.addLimot ( this, info, 4, ax1, 0 );
+        row += limotP.addLinearLimot ( this, info,  ax1, 4 );
     }
     else if (flags & dJOINT_REVERSE )
     {
@@ -414,12 +416,12 @@
         rAx1[0] = -ax1[0];
         rAx1[1] = -ax1[1];
         rAx1[2] = -ax1[2];
-        row += limotP.addLimot ( this, info, 4, rAx1, 0 );
+        row += limotP.addLinearLimot ( this, info,  rAx1, 4 );
     }
     else
-        row += limotP.addLimot ( this, info, 4, ax1, 0 );
+        row += limotP.addLinearLimot ( this, info, ax1, 4 );
 
-    limotR.addLimot ( this, info, row, ax1, 1 );
+    limotR.addRotationalLimot ( this, info, ax1, row );
 }
 
 void dJointSetPistonAnchor ( dJointID j, dReal x, dReal y, dReal z )
Index: ode/src/joints/plane2d.cpp
===================================================================
--- ode/src/joints/plane2d.cpp	(revision 1903)
+++ ode/src/joints/plane2d.cpp	(working copy)
@@ -64,7 +64,10 @@
 void 
 dxJointPlane2D::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+    info->max_m = 3 +
+      motor_x.countSureMaxRows() +
+      motor_y.countSureMaxRows() +
+      motor_angle.countSureMaxRows();
 }
 
 
@@ -74,20 +77,12 @@
     info->nub = 3;
     info->m = 3;
 
-    if ( motor_x.fmax > 0 )
-        row_motor_x = info->m++;
-    else
-        row_motor_x = 0;
-
-    if ( motor_y.fmax > 0 )
-        row_motor_y = info->m++;
-    else
-        row_motor_y = 0;
-
-    if ( motor_angle.fmax > 0 )
-        row_motor_angle = info->m++;
-    else
-        row_motor_angle = 0;
+    info->m += motor_x.countRows();
+    info->nub += motor_x.countUBRows();
+    info->m += motor_y.countRows();
+    info->nub += motor_y.countUBRows();
+    info->m += motor_angle.countRows();
+    info->nub += motor_angle.countUBRows();
 }
 
 
@@ -139,14 +134,10 @@
 
     // if the slider is powered, or has joint limits, add in the extra row:
 
-    if ( row_motor_x > 0 )
-        motor_x.addLimot( this, info, row_motor_x, Midentity[0], 0 );
-
-    if ( row_motor_y > 0 )
-        motor_y.addLimot( this, info, row_motor_y, Midentity[1], 0 );
-
-    if ( row_motor_angle > 0 )
-        motor_angle.addLimot( this, info, row_motor_angle, Midentity[2], 1 );
+    int row = 3;
+    row += motor_x.addLinearLimot( this, info,  Midentity[0], row );
+    row += motor_y.addLinearLimot( this, info,  Midentity[1], row );
+    motor_angle.addRotationalLimot( this, info, Midentity[2], row );
 }
 
 
Index: ode/src/joints/plane2d.h
===================================================================
--- ode/src/joints/plane2d.h	(revision 1903)
+++ ode/src/joints/plane2d.h	(working copy)
@@ -30,9 +30,9 @@
 
 struct dxJointPlane2D : public dxJoint
 {
-    int                 row_motor_x;
-    int                 row_motor_y;
-    int                 row_motor_angle;
+    //int                 row_motor_x;
+    //int                 row_motor_y;
+    //int                 row_motor_angle;
     dxJointLimitMotor   motor_x;
     dxJointLimitMotor   motor_y;
     dxJointLimitMotor   motor_angle;
Index: ode/src/joints/pr.cpp
===================================================================
--- ode/src/joints/pr.cpp	(revision 1903)
+++ ode/src/joints/pr.cpp	(working copy)
@@ -180,7 +180,9 @@
 void 
 dxJointPR::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 4 + 
+    limotR.countSureMaxRows() +
+    limotP.countSureMaxRows();
 }
 
 
@@ -203,7 +205,8 @@
     }
 
     // powered needs an extra constraint row
-    if ( limotP.limit || limotP.fmax > 0 ) info->m++;
+    info->m += limotP.countRows();
+    info->nub += limotP.countUBRows();
 
 
     // see if we're at a joint limit.
@@ -430,7 +433,7 @@
     int row = 4;
     if (  node[1].body || !(flags & dJOINT_REVERSE) )
     {
-        row += limotP.addLimot ( this, info, 4, axP, 0 );
+        row += limotP.addLinearLimot ( this, info, axP, 4 );
     }
     else
     {
@@ -438,10 +441,10 @@
         rAxP[0] = -axP[0];
         rAxP[1] = -axP[1];
         rAxP[2] = -axP[2];
-        row += limotP.addLimot ( this, info, 4, rAxP, 0 );
+        row += limotP.addLinearLimot ( this, info, rAxP, 4 );
     }
 
-    limotR.addLimot ( this, info, row, ax1, 1 );
+    limotR.addRotationalLimot ( this, info, ax1, row );
 }
 
 
Index: ode/src/joints/pu.cpp
===================================================================
--- ode/src/joints/pu.cpp	(revision 1903)
+++ ode/src/joints/pu.cpp	(working copy)
@@ -209,7 +209,10 @@
 void 
 dxJointPU::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 3 +
+    limotP.countSureMaxRows() +
+    limot1.countSureMaxRows() +
+    limot2.countSureMaxRows();
 }
 
 
@@ -232,7 +235,8 @@
         limotP.testRotationalLimit( pos );  // N.B. The function is ill named
     }
 
-    if ( limotP.limit || limotP.fmax > 0 ) info->m++;
+    info->m+=limotP.countRows();
+    info->nub+=limotP.countUBRows();
 
 
     bool limiting1 = ( limot1.lostop >= -M_PI || limot1.histop <= M_PI ) &&
@@ -254,8 +258,13 @@
             limot2.testRotationalLimit( angle2 );
     }
 
-    if ( limot1.limit || limot1.fmax > 0 ) info->m++;
-    if ( limot2.limit || limot2.fmax > 0 ) info->m++;
+    //if ( limot1.limit || limot1.fmax > 0 ) info->m++;
+    //if ( limot2.limit || limot2.fmax > 0 ) info->m++;
+
+    info->m   += limot1.countRows();
+    info->nub += limot1.countUBRows();
+    info->m   += limot2.countRows();
+    info->nub += limot2.countUBRows();
 }
 
 
@@ -434,17 +443,17 @@
     info->c[1] = k * dCalcVectorDot3( ax1, err );
     info->c[2] = k * dCalcVectorDot3( q, err );
 
-    int row = 3 + limot1.addLimot( this, info, 3, ax1, 1 );
-    row += limot2.addLimot( this, info, row, ax2, 1 );
+    int row = 3 + limot1.addRotationalLimot( this, info,  ax1, 3 );
+    row += limot2.addRotationalLimot( this, info, ax2, row );
 
     if (  node[1].body || !(flags & dJOINT_REVERSE) )
-        limotP.addLimot( this, info, row, axP, 0 );
+        limotP.addLinearLimot( this, info, axP, row );
     else
     {
         axP[0] = -axP[0];
         axP[1] = -axP[1];
         axP[2] = -axP[2];
-        limotP.addLimot ( this, info, row, axP, 0 );
+        limotP.addLinearLimot ( this, info, axP, row );
     }
 }
 
Index: ode/src/joints/slider.cpp
===================================================================
--- ode/src/joints/slider.cpp	(revision 1903)
+++ ode/src/joints/slider.cpp	(working copy)
@@ -109,7 +109,7 @@
 void 
 dxJointSlider::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 5 + limot.countSureMaxRows();
 }
 
 
@@ -117,12 +117,8 @@
 dxJointSlider::getInfo1 ( dxJoint::Info1 *info )
 {
     info->nub = 5;
+    info->m = 5;
 
-    // see if joint is powered
-    if ( limot.fmax > 0 )
-        info->m = 6; // powered slider needs an extra constraint row
-    else info->m = 5;
-
     // see if we're at a joint limit.
     limot.limit = 0;
     if ( ( limot.lostop > -dInfinity || limot.histop < dInfinity ) &&
@@ -130,18 +126,9 @@
     {
         // measure joint position
         dReal pos = dJointGetSliderPosition ( this );
-        if ( pos <= limot.lostop )
-        {
-            limot.limit = 1;
-            limot.limit_err = pos - limot.lostop;
-            info->m = 6;
-        }
-        else if ( pos >= limot.histop )
-        {
-            limot.limit = 2;
-            limot.limit_err = pos - limot.histop;
-            info->m = 6;
-        }
+        limot.testRotationalLimit( pos );
+        info->m+=limot.countRows();
+        info->nub+=limot.countUBRows();
     }
 }
 
@@ -224,7 +211,7 @@
     }
 
     // if the slider is powered, or has joint limits, add in the extra row
-    limot.addLimot ( this, info, 5, ax1, 0 );
+    limot.addLinearLimot ( this, info, ax1, 5 );
 }
 
 
